---
- name: "install_redis | Install Redis"
  notify:
    - "Enable and start Redis"
  block:
    - name: "install_redis | Install and required packages"
      retries: 3
      delay: 10
      until: "output is success"
      register: "output"
      ansible.builtin.package:
        name:
          - "redis"

    - name: "install_redis | Import Redis service file"
      ansible.builtin.template:
        src: "redis-server.service.j2"
        dest: "/lib/systemd/system/redis-server.service"
        owner: "root"
        group: "root"
        mode: "0600"

    - name: "install_redis | Fix permissions on Redis conf dir and create folders"
      changed_when: false
      loop:
        - "/etc/redis/"
        - "{{ install_redis.log_path }}"
        - "{{ install_redis.ssl_path }}"
        - "/var/lib/redis"
      loop_control:
        loop_var: "path"
      ansible.builtin.file:
        path: "{{ path }}"
        state: "directory"
        recurse: true
        owner: "{{ install_redis.system_user }}"
        group: "{{ install_redis.system_group }}"
        mode: "0700"

- name: "install_redis | Configure Redis"
  notify: "Restart Redis"
  block:
    - name: "install_redis | Import Redis server configuration"
      ansible.builtin.template:
        src: "redis.conf.j2"
        dest: "/etc/redis/redis.conf"
        owner: "{{ install_redis.system_user }}"
        group: "{{ install_redis.system_group }}"
        mode: "0700"
